#!/bin/bash
set -ex

pushd "${0%/*}"


export CC=clang
export CXX=clang++

pushd deps
pushd IES
if [[ -d "build" ]]; then
  rm -r build
fi
mkdir build
if command -v git &> /dev/null; then
  git clean -f -d -x
fi
export CFLAGS="-ggdb -O0"
export CXXFLAGS="-ggdb -O0"
./autogen.sh
./configure --enable-shared --prefix "$(pwd)/build"
make clean
make -j$(nproc)
make install

popd
pushd rapidyaml
if [[ -d "build" ]]; then
  rm -r build
fi
if [[ -d "install" ]]; then
  rm -r install
fi
mkdir build
mkdir install
pushd build
export CFLAGS="-D_GNU_SOURCE -ggdb -O2"
export CXXFLAGS="-D_GNU_SOURCE -ggdb -O2"
cmake .. -DRYML_BUILD_TESTS=OFF -DCMAKE_POSITION_INDEPENDENT_CODE=ON -DCMAKE_CXX_STANDARD=17 -DCMAKE_INSTALL_PREFIX="$(pwd)/../install"
make -j$(nproc)
make install