#pragma once

#include <cstdint>
#include <cfloat>

namespace FM10K{

    constexpr uint32_t VR12_VID_to_Millivolts(uint8_t v){
        return v == 0 ? 0 : 5 * (v - 1) + 250;
    }

    constexpr uint32_t Volts_to_Millivolts(double v){
        return static_cast<uint32_t>(v * 1000.0);
    }

    constexpr uint8_t Millivolts_to_VR12_VID(uint32_t v){
        return ((v - 250) / 5) + 1;
    }

}