#pragma once

#include "Register.h"

namespace FM10K {
    namespace registers {
        namespace CM_USAGE {
            const uint32_t BASE_ADDRESS = 0xE60000;
            const uint32_t CLASS_ENTRIES = 48;

            PACKEDA(CM_GLOBAL_WM, 0x852, struct {
                uint16_t watermark: 15;
                uint32_t : 17;
                }, uint32_t);
            PACKEDA(CM_GLOBAL_CFG, 0x853, struct {
                uint8_t ifgPenalty: 8;
                uint8_t forcePauseOn: 1;
                uint8_t forcePauseOff: 1;
                uint8_t WmSweeperEnable: 1;
                uint8_t PauseGenSweeperEnable: 1;
                uint8_t PauseRecSweeperEnable: 1;
                uint8_t NumSweeperPorts: 6;
                uint16_t : 13;
                }, uint32_t) ;

            const uint32_t CM_EGRESS_PAUSE_COUNT__Address = BASE_ADDRESS + 0x1400; //128-bit entries
        }
    }
}


