#pragma once

#include "Register.h"

namespace FM10K {
    namespace registers {
        namespace EPL {
            const uint32_t BASE_ADDRESS = 0x0E0000;

            const uint32_t EPL_OFFSET = 0x400;

            PACKEDA(EPL_CFG_A, 0x304, struct {
                uint8_t SpeedUp: 1;
                uint8_t Timeout: 6;
                uint8_t Active: 4; // [0..3]
                uint8_t SkewTolerance: 6;
                uint8_t RxLaneflipEn: 1;
                uint8_t TxLaneflipEn: 1;
                uint16_t :15;
                }, uint32_t);
        }
    }
}


