#pragma once

#include "Register.h"

namespace FM10K {
    namespace registers {
        namespace SCHED {
            const uint32_t BASE_ADDRESS = 0xF00000;

            PACKEDA(SCHED_SSCHED_RX_PERPORT, 0x20840, struct {
                uint16_t Next: 16;
                uint16_t : 16;
                }, uint32_t);
            const uint32_t SCHED_SSCHED_RX_PERPORT__Entries = 48;

            PACKEDA(SCHED_FREELIST_INIT, 0x30244, struct {
                uint16_t Address: 16;
                uint16_t : 16;
                }, uint32_t);

            PACKEDAM(SCHED_RXQ_STORAGE_POINTERS, 0x60400, struct {
                uint16_t HeadPage: 10;
                uint16_t TailPage: 10;
                uint16_t HeadIdx: 5;
                uint16_t TailIdx: 5;
                uint16_t NextPage: 10;
                uint32_t : 24;
                }, uint32_t, 2); //[0..7]
            const uint32_t SCHED_RXQ_STORAGE_POINTERS__Entries = 8;

            PACKEDA(SCHED_RXQ_FREELIST_INIT, 0x60410, struct {
                uint16_t Address: 10;
                uint32_t : 22;
                }, uint32_t);

            PACKEDA(SCHED_TXQ_HEAD_PERQ, 0x60A00, struct {
                uint16_t Head: 16;
                uint16_t : 16;
                }, uint32_t);
            const uint32_t SCHED_TXQ_HEAD_PERQ__Entries = 384;

            PACKEDA(SCHED_TXQ_FREELIST_INIT, 0x62000, struct {
                uint16_t Address: 16;
                uint16_t : 16;
                }, uint32_t);

            PACKEDA(SCHED_TXQ_TAIL0_PERQ, 0x60600, struct {
                uint16_t Tail: 16;
                uint16_t : 16;
                }, uint32_t);

            PACKEDA(SCHED_TXQ_TAIL1_PERQ, 0x60800, struct {
                uint16_t Tail: 16;
                uint16_t : 16;
                }, uint32_t);
        }
    }
}


